// Preferences observer object; implements nsIObserver
function objDownloadWith(pref)
{
	///////////// Private variables /////////////
	var preference = pref;
	var bundle;

	///////////// Public Methods /////////////
	this.init = function() {
		bundle = document.getElementById("downloadwithbundle");
		document.getElementById("contentAreaContextMenu").addEventListener("popupshowing",this.hideMenu,false);
	}

	this.commanded = function(e,menu) {
		var t = e.target;
		if (t.id != "downloadwith-invalide-url") {
		// load url
			var baseurl = t.getAttribute("label");
			if(/http:\/\//.test(baseurl)) {
				baseurl = "http:\/\/" + baseurl.split("http:\/\/")[1];
			} else if (/ftp:\/\//.test(baseurl)) {
				baseurl = "ftp:\/\/" + baseurl.split("ftp:\/\/")[1];
			} 
			// Execute application
			var application = preference.getApplication(t.id);
			var label = application[preference.LABEL];
			var command = application[preference.COMMAND];
			var arguments = application[preference.ARGS];
      
			// replace URL 
			var strArgs = arguments.replace(/\[URL\]/, baseurl);
			// separate command arguments
			var args = new Array();
			var quoted = false;
			var double_quoted = false;
			var param = "";
			for (var i = 0; i < strArgs.length; i++) { 
				var charArgs = strArgs.substring(i,i + 1);
				if ( charArgs == "\""  && !quoted ) { double_quoted =! double_quoted; }
				else if ( charArgs == "\'" && !double_quoted ) { quoted =! quoted; } 
				else if ( /\s/.test(charArgs) && !quoted && !double_quoted ) {
					if (param != "") args.push( param );
				param = "";
				} else param += charArgs;	
			}
			if (param != "") args.push( param );
			// create a file object for the external program
			try {
				var applicFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
				var applic = Components.classes["@mozilla.org/process/util;1"].createInstance(Components.interfaces.nsIProcess);
      
				applicFile.initWithPath(command);
				if (! applicFile.exists()) {
					downloadwithError("Executable '" + command + "' does not exist.");
				} else {
					applic.init(applicFile);
					applic.run(false, args, args.length);
				}
			} 
			catch (e) {
				downloadwithError("Cannot run executable: " + e);
				return false;
			}
		}
		if(e.button==1) menu.hidePopup();  
	}

	// called onPopupShowing for the main context menu. hides DownloadWith if it's not relevant
	this.hideMenu = function() {
		var cm = gContextMenu;
		document.getElementById("context-downloadwith").hidden = !cm.onLink;
	}

	this.clearMenu = function(menu) {
		while(menu.hasChildNodes()) menu.removeChild(menu.lastChild);
	}

	// wander out from the node the context menu was called on and try and find a link
	// return the href attribute.
	// in future this may need expanding to deal with xlinks, but we'll live without for now
	this.getLink = function() {
		var elem = document.popupNode;
		while(elem) {
			if(elem instanceof Components.interfaces.nsIDOMHTMLAnchorElement && elem.href)
				return elem.href;
			elem = elem.parentNode;
		}
		return null;
	}

	this.buildMenu = function(menu) {
		var url = this.getLink();
		if(!url) return;
		if(/^(ht|f)tp:\/\//.test(url)) {
			for (var application = preference.getFirstApplication();application != null;application = preference.getNextApplication()) {
				if (application[preference.LABEL] != null && application[preference.LABEL] != "" ) this.addItemApplication(menu,url,application[preference.IDENT],application[preference.LABEL]);
			}
		} else {
			this.addItemInvalide(menu);
		}
	}
    
	this.addItemInvalide = function(menu) {
		var menuitem = document.createElement("menuitem");
		menuitem.setAttribute("label",bundle.getString("invalideURL"));
		menuitem.setAttribute("id","downloadwith-invalide-url");
		menu.appendChild(menuitem);
	}
  
	this.addItemApplication = function(menu,url,id,label) {
		var menuitem = document.createElement("menuitem");
		menuitem.setAttribute("label",label  + " " + url);
		menuitem.setAttribute("id",id);
		menu.appendChild(menuitem);
	}
}